<?php
/**
 * ModuleFieldMatching
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Message Business API
 *
 * REST API allowing you to interact with your message business account.
 *
 * OpenAPI spec version: v4
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * ModuleFieldMatching Class Doc Comment
 *
 * @category    Class */
/** 
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ModuleFieldMatching implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ModuleFieldMatching';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = array(
        'mod_field_label' => 'string',
        'mod_field_name' => 'string',
        'mod_attribute_type' => 'string',
        'mb_attribute_name' => 'string',
        'mb_user_defined' => 'bool',
        'json_map_values' => 'string'
    );

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = array(
        'mod_field_label' => 'modFieldLabel',
        'mod_field_name' => 'modFieldName',
        'mod_attribute_type' => 'modAttributeType',
        'mb_attribute_name' => 'MbAttributeName',
        'mb_user_defined' => 'MbUserDefined',
        'json_map_values' => 'jsonMapValues'
    );

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = array(
        'mod_field_label' => 'setModFieldLabel',
        'mod_field_name' => 'setModFieldName',
        'mod_attribute_type' => 'setModAttributeType',
        'mb_attribute_name' => 'setMbAttributeName',
        'mb_user_defined' => 'setMbUserDefined',
        'json_map_values' => 'setJsonMapValues'
    );

    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = array(
        'mod_field_label' => 'getModFieldLabel',
        'mod_field_name' => 'getModFieldName',
        'mod_attribute_type' => 'getModAttributeType',
        'mb_attribute_name' => 'getMbAttributeName',
        'mb_user_defined' => 'getMbUserDefined',
        'json_map_values' => 'getJsonMapValues'
    );

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = array();

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['mod_field_label'] = isset($data['mod_field_label']) ? $data['mod_field_label'] : null;
        $this->container['mod_field_name'] = isset($data['mod_field_name']) ? $data['mod_field_name'] : null;
        $this->container['mod_attribute_type'] = isset($data['mod_attribute_type']) ? $data['mod_attribute_type'] : null;
        $this->container['mb_attribute_name'] = isset($data['mb_attribute_name']) ? $data['mb_attribute_name'] : null;
        $this->container['mb_user_defined'] = isset($data['mb_user_defined']) ? $data['mb_user_defined'] : null;
        $this->container['json_map_values'] = isset($data['json_map_values']) ? $data['json_map_values'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = array();
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets mod_field_label
     * @return string
     */
    public function getModFieldLabel()
    {
        return $this->container['mod_field_label'];
    }

    /**
     * Sets mod_field_label
     * @param string $mod_field_label
     * @return $this
     */
    public function setModFieldLabel($mod_field_label)
    {
        $this->container['mod_field_label'] = $mod_field_label;

        return $this;
    }

    /**
     * Gets mod_field_name
     * @return string
     */
    public function getModFieldName()
    {
        return $this->container['mod_field_name'];
    }

    /**
     * Sets mod_field_name
     * @param string $mod_field_name
     * @return $this
     */
    public function setModFieldName($mod_field_name)
    {
        $this->container['mod_field_name'] = $mod_field_name;

        return $this;
    }

    /**
     * Gets mod_attribute_type
     * @return string
     */
    public function getModAttributeType()
    {
        return $this->container['mod_attribute_type'];
    }

    /**
     * Sets mod_attribute_type
     * @param string $mod_attribute_type
     * @return $this
     */
    public function setModAttributeType($mod_attribute_type)
    {
        $this->container['mod_attribute_type'] = $mod_attribute_type;

        return $this;
    }

    /**
     * Gets mb_attribute_name
     * @return string
     */
    public function getMbAttributeName()
    {
        return $this->container['mb_attribute_name'];
    }

    /**
     * Sets mb_attribute_name
     * @param string $mb_attribute_name
     * @return $this
     */
    public function setMbAttributeName($mb_attribute_name)
    {
        $this->container['mb_attribute_name'] = $mb_attribute_name;

        return $this;
    }

    /**
     * Gets mb_user_defined
     * @return bool
     */
    public function getMbUserDefined()
    {
        return $this->container['mb_user_defined'];
    }

    /**
     * Sets mb_user_defined
     * @param bool $mb_user_defined
     * @return $this
     */
    public function setMbUserDefined($mb_user_defined)
    {
        $this->container['mb_user_defined'] = $mb_user_defined;

        return $this;
    }

    /**
     * Gets json_map_values
     * @return string
     */
    public function getJsonMapValues()
    {
        return $this->container['json_map_values'];
    }

    /**
     * Sets json_map_values
     * @param string $json_map_values
     * @return $this
     */
    public function setJsonMapValues($json_map_values)
    {
        $this->container['json_map_values'] = $json_map_values;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}


