<?php
/**
 * ReceiversOperation
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Message Business API
 *
 * REST API allowing you to interact with your message business account.
 *
 * OpenAPI spec version: v4
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * ReceiversOperation Class Doc Comment
 *
 * @category    Class */
 // @description This contain the different possible selection of contacts for an operation.
/** 
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ReceiversOperation implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ReceiversOperation';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = array(
        'segment_ids' => 'int[]',
        'import_ids' => 'int[]',
        'contact_ids' => 'int[]',
        'conditions_xml' => 'string',
        'conditions_mode' => 'string'
    );

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = array(
        'segment_ids' => 'segmentIds',
        'import_ids' => 'importIds',
        'contact_ids' => 'contactIds',
        'conditions_xml' => 'conditionsXml',
        'conditions_mode' => 'conditionsMode'
    );

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = array(
        'segment_ids' => 'setSegmentIds',
        'import_ids' => 'setImportIds',
        'contact_ids' => 'setContactIds',
        'conditions_xml' => 'setConditionsXml',
        'conditions_mode' => 'setConditionsMode'
    );

    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = array(
        'segment_ids' => 'getSegmentIds',
        'import_ids' => 'getImportIds',
        'contact_ids' => 'getContactIds',
        'conditions_xml' => 'getConditionsXml',
        'conditions_mode' => 'getConditionsMode'
    );

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = array();

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['segment_ids'] = isset($data['segment_ids']) ? $data['segment_ids'] : null;
        $this->container['import_ids'] = isset($data['import_ids']) ? $data['import_ids'] : null;
        $this->container['contact_ids'] = isset($data['contact_ids']) ? $data['contact_ids'] : null;
        $this->container['conditions_xml'] = isset($data['conditions_xml']) ? $data['conditions_xml'] : null;
        $this->container['conditions_mode'] = isset($data['conditions_mode']) ? $data['conditions_mode'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = array();
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets segment_ids
     * @return int[]
     */
    public function getSegmentIds()
    {
        return $this->container['segment_ids'];
    }

    /**
     * Sets segment_ids
     * @param int[] $segment_ids Array of segment id
     * @return $this
     */
    public function setSegmentIds($segment_ids)
    {
        $this->container['segment_ids'] = $segment_ids;

        return $this;
    }

    /**
     * Gets import_ids
     * @return int[]
     */
    public function getImportIds()
    {
        return $this->container['import_ids'];
    }

    /**
     * Sets import_ids
     * @param int[] $import_ids Array of import id
     * @return $this
     */
    public function setImportIds($import_ids)
    {
        $this->container['import_ids'] = $import_ids;

        return $this;
    }

    /**
     * Gets contact_ids
     * @return int[]
     */
    public function getContactIds()
    {
        return $this->container['contact_ids'];
    }

    /**
     * Sets contact_ids
     * @param int[] $contact_ids Array of contact id
     * @return $this
     */
    public function setContactIds($contact_ids)
    {
        $this->container['contact_ids'] = $contact_ids;

        return $this;
    }

    /**
     * Gets conditions_xml
     * @return string
     */
    public function getConditionsXml()
    {
        return $this->container['conditions_xml'];
    }

    /**
     * Sets conditions_xml
     * @param string $conditions_xml XML formated
     * @return $this
     */
    public function setConditionsXml($conditions_xml)
    {
        $this->container['conditions_xml'] = $conditions_xml;

        return $this;
    }

    /**
     * Gets conditions_mode
     * @return string
     */
    public function getConditionsMode()
    {
        return $this->container['conditions_mode'];
    }

    /**
     * Sets conditions_mode
     * @param string $conditions_mode Criterias mode \"intersect\" or \"union\"
     * @return $this
     */
    public function setConditionsMode($conditions_mode)
    {
        $this->container['conditions_mode'] = $conditions_mode;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}


