<?php
/*
* 2011-2014 Message Business SAS
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to contact@messagebusiness.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade the Message Business module to newer
* versions in the future. If you wish to customize the Message Business module for your
* needs please refer to http://www.message-business.com/tools/redir-SMB/campus-prestashop.htm for more information.
*
*  @author		Message Business SAS <contact@messagebusiness.com>
*  @copyright	2011-2015 Message Business SAS
*  @version		1.64 on 2015/06/08 15:14:13 UTC
*  @license		http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of Message Business SAS
*
* Change for active / inactive customers
* ligne 169
* ligne 242
* ligne 276
*/
require_once('../../config/config.inc.php');
require_once (dirname(__FILE__).'/autoload.php');

function initMessageBusinessApi($config, $accountId, $apiKey) {
    $config->setUsername($accountId);
    $config->setPassword($apiKey);
    $config->setCurlTimeout(120);
    $config->setSSLVerification(false);
    return true;
}
$accessKey = Configuration::get('MB_PSKEY');

function getContactAttribute($mb_key, $value) {
    $contactAttribute = new Swagger\Client\Model\ContactAttribute;
	$contactAttribute->setId($mb_key);
    $contactAttribute->setFieldName($mb_key);
	$contactAttribute->setFieldValue($value);
    return ($contactAttribute);
}

function parse_jobs($string_module_job)
{
    
}
$ip = $_SERVER['REMOTE_ADDR'];
if (($ip == '217.174.192.17') || ($ip == '217.174.192.18') || ($ip == '217.174.192.19') || ($ip == '217.174.192.24') || ($ip == '217.174.192.20') || ($ip == '217.174.192.21') || ($ip == '217.174.192.22') || ($ip == '217.174.192.23') || ($ip == '217.174.192.16') || ($ip == '127.0.0.1') || ($ip == '185.136.43.7'))
{
    header('Content-Type: application/json');
    $_GET['customerid'] = 1;
    
    if(($_GET['request'] == 'optindata') && ($accessKey == $_GET['accesskey']) && isset($_POST['moduleJob']) && ($_POST['moduleJob'] !== '') && isset($_POST['customersData']) && ($_POST['customersData'] !== '') && isset($_POST['customersIndex']) && ($_POST['customersIndex'] !== ''))
	{
        $return = array();
        $return['result'] = 0;
		$return['message'] = "";
        $modOperation = json_decode($_POST['moduleJob']);
        $customerData = json_decode($_POST['customersData']);
        $customerIndex = json_decode($_POST['customersIndex'], true);
        
        $ArrayContactKey = array();
        $ExistingValues = array();
		foreach ($modOperation->modFieldMb as $key => $value) {
            $AttributeRelation[$value->modFieldName] = $value->MbAttributeName;
			if ($value->jsonMapValues != null) {
				$value_exist = json_decode($value->jsonMapValues);
				$ExistingValues[$value->modFieldName] = array();
				foreach ($value_exist as $jindex_value => $jvalue_value) {
					//error_log($value->modFieldName . ' ' . $jindex_value . ' ' . $jvalue_value);
                    $ExistingValues[$value->modFieldName][$jvalue_value] = $jindex_value;
                }
			}
        }

        foreach ($customerData as $customerMb) {
            $newsletter_value = '';
            $optinpartner_value = '';
            if (isset($customerIndex['prestashop_optin']) && isset($ExistingValues['newsletter'][$customerMb[$customerIndex['prestashop_optin']]])) {
                $newsletter_value = $ExistingValues['newsletter'][$customerMb[$customerIndex['prestashop_optin']]];
            }
            if  (isset($customerIndex['prestashop_optinpartners']) && isset($ExistingValues['optin'][$customerMb[$customerIndex['prestashop_optinpartners']]])) {
                $optinpartner_value = $ExistingValues['optin'][$customerMb[$customerIndex['prestashop_optinpartners']]];
            }
			$news_module = false;
			$news_dbname = 'newsletter';
			if (Module::isInstalled('blocknewsletter')) {
				$news_module = true;
			} else if (Module::isInstalled('ps_emailsubscription')) {
				$news_module = true;
				$news_dbname = 'emailsubscription';
			}
            //if ((Module::isInstalled('blocknewsletter')) && ($newsletter_value == '0') && (strlen($customerMb[$customerIndex['email']]) > 0)) {
			if (($news_module) && ($newsletter_value == '0') && (strlen($customerMb[$customerIndex['email']]) > 0)) {
                //$sql = 'DELETE FROM `'._DB_PREFIX_.'customer` WHERE email = '.pSQL($customerMb[$customerIndex["email"]]);
                Db::getInstance()->delete($news_dbname, 'email=\''. pSQL($customerMb[$customerIndex["email"]]).'\'');
                //Db::getInstance()->ExecuteS($sql);
                $return['result']++;
            }
			
            if (isset($customerIndex["prestashop_customerid"]) && (isset($customerMb[$customerIndex["prestashop_customerid"]])) && (is_numeric($customerMb[$customerIndex["prestashop_customerid"]]))) {
                $exec_sql = false;
                $sql_optinupdate = 'UPDATE `'._DB_PREFIX_.'customer` SET ';
                if ($newsletter_value != '') {
                    $sql_optinupdate .= 'newsletter='.$newsletter_value.' ';
                    $exec_sql = true;
                }
                if ($optinpartner_value != '') {
                    if ($exec_sql) {
                        $sql_optinupdate .= ', ';
                    }
                    $sql_optinupdate .= 'optin='.$optinpartner_value.' ';
                    $exec_sql = true;
                }
                if ($exec_sql) {
                    $return['message'] = Db::getInstance()->Execute($sql_optinupdate.' WHERE deleted=0 AND id_customer='. pSQL($customerMb[$customerIndex["prestashop_customerid"]]));
                    $return['result']++;
                }
            }
        }
        echo json_encode($return);
    }
	else if(($_GET['request'] == 'newsletterdata') && ($accessKey == $_GET['accesskey']) && isset($_POST['moduleJob']) && ($_POST['moduleJob'] !== ''))
	{
		$return = array();
        $return['result'] = 1;
		Configuration::updateValue('MB_NEWSLETTER', pSQL($_POST['moduleJob']));
		echo json_encode($return);
	}
	elseif(($_GET['request'] == 'allsubscribers') && ($accessKey == $_GET['accesskey']) && isset($_POST['moduleJob']) && ($_POST['moduleJob'] !== ''))
	{
        $return = array('message' => '',
        'result' => 0);
        $recentSub = Array();
        $ExistingValues = array();
        $AttributeRelation = array();
		$moduleJob = json_decode($_POST['moduleJob']);
        foreach ($moduleJob->modFieldMb as $key => $value) {
            $AttributeRelation[$value->modFieldName] = $value->MbAttributeName;
			if ($value->jsonMapValues != null) {
				$value_exist = json_decode($value->jsonMapValues);
				$ExistingValues[$value->modFieldName] = array();
				foreach ($value_exist as $jindex_value => $jvalue_value) {
					//error_log($value->modFieldName . ' ' . $jindex_value . ' ' . $jvalue_value);
                    $ExistingValues[$value->modFieldName][$jindex_value] = $jvalue_value;
                }
			}
        }
		$contactsApi = new Swagger\Client\Api\ContactsApi();
        initMessageBusinessApi($contactsApi->getApiClient()->getConfig(), Configuration::get('MB_ACCOUNTID'), Configuration::get('MB_APIKEY'));
		$news_module = false;
		$news_dbname = 'newsletter';
		if (Module::isInstalled('blocknewsletter')) {
			$news_module = true;
		} else if (Module::isInstalled('ps_emailsubscription')) {
			$news_module = true;
			$news_dbname = 'emailsubscription';
		}
		if ($news_module)
		{
			//with inactive customers
			$rowNewsletters = Db::getInstance()->ExecuteS('SELECT email,newsletter_date_add FROM `'._DB_PREFIX_.$news_dbname.'`');
			//without inactive customers
			//$rowNewsletters = Db::getInstance()->ExecuteS('SELECT email,newsletter_date_add FROM `'._DB_PREFIX_.$news_dbname.'` WHERE active = 1');
            $recentSub = array();
			$i = 0;
			/*if (isset($customerIndex['prestashop_optin']) && isset($ExistingValues['newsletter'][$customerMb[$customerIndex['prestashop_optin']]])) {
                $newsletter_value = $ExistingValues['newsletter'][$customerMb[$customerIndex['prestashop_optin']]];
            }*/
			foreach ($rowNewsletters as $rowNewsletter)
			{
				$contact = new Swagger\Client\Model\ContactData();
                $contactAttributes=[];
				if (isset($AttributeRelation['newsletter_date_add']) && ($rowNewsletter['newsletter_date_add'] != 0)) {
					$datenews = date("Y-m-d", strtotime($rowNewsletter['newsletter_date_add']));
					$contactAttributes[0] = ["id" => $AttributeRelation['newsletter_date_add'], "fieldName" => $AttributeRelation['newsletter_date_add'], "fieldValue" => $datenews];
					if (isset($AttributeRelation['newsletter']) && isset($ExistingValues['newsletter'])) {
						$final_value = $ExistingValues['newsletter'][1];
						$contactAttributes[1] = ["id" => $AttributeRelation['newsletter'], "fieldName" => $AttributeRelation['newsletter'], "fieldValue" => $final_value];
					}
					//array_push($contactAttributes, getContactAttribute($AttributeRelation['newsletter_date_add'], $datenews));
					$contact->setContactKey($rowNewsletter['email']);//CHECK WITH  $moduleJob->modUnicityField
					$contact->setAttributes($contactAttributes);
					$recentSub[$i++] = array(
						"contactKey" => $rowNewsletter['email'],
						"attributes" => $contactAttributes
					);
				}
                if ($i > 399) {
					$contactsApi->contactsPostContactsAttributeKey($recentSub);
                    $return['message'] = '/'.$return['result'].':';
                    $return['result']++;
                    $recentSub = array();
                    $i = 0;
                }
			}
			if (count($recentSub) > 0) {
				$contactsApi->contactsPostContactsAttributeKey($recentSub);
				$return['message'] .= '/'.$return['result'].':';
				$return['result']++;
			}
		}
        echo json_encode($return);
	}
	elseif(($_GET['request'] == 'recentsubscribers') && ($accessKey == $_GET['accesskey']) && isset($_POST['moduleJob']) && ($_POST['moduleJob'] !== ''))
	{
		$return = array('message' => '', 'result' => 0);
        $recentSub = Array();
        $ExistingValues = array();
        $AttributeRelation = array();
        $moduleJob = json_decode($_POST['moduleJob']);
		foreach ($moduleJob->modFieldMb as $key => $value) {
            $AttributeRelation[$value->modFieldName] = $value->MbAttributeName;
			if ($value->jsonMapValues != null) {
				$value_exist = json_decode($value->jsonMapValues);
				$ExistingValues[$value->modFieldName] = array();
				foreach ($value_exist as $jindex_value => $jvalue_value) {
					//error_log($value->modFieldName . ' ' . $jindex_value . ' ' . $jvalue_value);
                    $ExistingValues[$value->modFieldName][$jindex_value] = $jvalue_value;
                }
			}
        }
		//'ps_emailsubscription'
		$news_module = false;
		$news_dbname = 'newsletter';
		if (Module::isInstalled('blocknewsletter')) {
			$news_module = true;
		} else if (Module::isInstalled('ps_emailsubscription')) {
			$news_module = true;
			$news_dbname = 'emailsubscription';
		}
		if ($news_module)
		{
			//with inactive customer
			$request = Db::getInstance()->ExecuteS('SELECT email,newsletter_date_add FROM `'._DB_PREFIX_.$news_dbname.'` WHERE newsletter_date_add>\''. pSQL($_GET['date']).'\' ORDER BY id_customer');
			//without inactive customer
			//$request = Db::getInstance()->ExecuteS('SELECT email,newsletter_date_add FROM `'._DB_PREFIX_.$news_dbname.'` WHERE newsletter_date_add>\''. pSQL($_GET['date']).'\' and active = 1 ORDER BY id_customer');
            $contactsApi = new Swagger\Client\Api\ContactsApi();
            initMessageBusinessApi($contactsApi->getApiClient()->getConfig(), Configuration::get('MB_ACCOUNTID'), Configuration::get('MB_APIKEY'));
            $i = 0;
            $recentSub = array();
			foreach ($request as $row)
			{
                $contact = new Swagger\Client\Model\ContactData;
                if ($row['newsletter_date_add'] != 0) {
                    $contactAttributes = array(0 => getContactAttribute($AttributeRelation['newsletter_date_add'], date("Y-m-d", strtotime($row['newsletter_date_add']))));
                    $contact->setContactKey($row['email']);
                    $contact->setAttributes($contactAttributes);
                    array_push($recentSub, $contact);
                    $i++;
                }
                if ($i > 299) {
                    $return['message_'+$return['result']] = $contactsApi->contactsPostContactsAttributeKey($recentSub);
                    $return['result']++;
                    $recentSub = array();
                    $i = 0;
                }
			}
            if (count($recentSub) > 0) {
                $return['message_'+$return['result']] = $contactsApi->contactsPostContactsAttributeKey($recentSub);
                $return['result']++;
            }
		}
        echo json_encode($return);
	}
	elseif(($_GET['request'] == 'allcustomerids') && ($accessKey == $_GET['accesskey']))
	{
		//with inactive customers
		$request = Db::getInstance()->ExecuteS('SELECT id_customer FROM `'._DB_PREFIX_.'customer` ORDER BY id_customer');
		//without inactive customers
		//$request = Db::getInstance()->ExecuteS('SELECT id_customer FROM `'._DB_PREFIX_.'customer` WHERE active = 1 ORDER BY id_customer');
		$i = 0;
        $idList = array(count($request));
		foreach ($request as $row)
		{
			$idList[$i++] = $row['id_customer'];
		}
		echo json_encode($idList);
	}
	elseif(($_GET['request'] == 'diagnostic') && ($accessKey == $_GET['accesskey']))
	{
		$object_stored = array(
			'MB_ACCOUNTID' => Configuration::get('MB_ACCOUNTID'),
			'MB_APIKEY' => Configuration::get('MB_APIKEY'),
			'MB_ACCEPTINTERFACEOPTION' => Configuration::get('MB_ACCEPTINTERFACEOPTION'),
			'MB_ACCEPTINTERFACELEVEL' => Configuration::get('MB_ACCEPTINTERFACELEVEL'),
			'MB_ACCEPTBLOCK' => Configuration::get('MB_ACCEPTBLOCK'),
			'MB_OPTINID' => Configuration::get('MB_OPTINID'),
			'MB_OPTINIDYES' => Configuration::get('MB_OPTINIDYES'),
			'MB_OPTINIDNO' => Configuration::get('MB_OPTINIDNO'),
			'MB_DATEADD' => Configuration::get('MB_DATEADD'),
			'MB_NEWSLETTER' => Configuration::get('MB_NEWSLETTER'),
			'MB_TEXTBOX' => Configuration::get('MB_TEXTBOX'),
			'MB_IPS' => Configuration::get('MB_IPS'),
			'MB_GROUP' => Configuration::get('MB_GROUP'),
			'MB_WEBURL' => Configuration::get('MB_WEBURL')
		);
		if (isset($_GET['id']) && (is_numeric($_GET['id']))) {
			$interval_f = '2 DAY';
			if (isset($_GET['fromint'])) {
				$interval_f = $_GET['fromint'];
			}
			$interval_s = '3 HOUR';
			if (isset($_GET['sinceint'])) {
				$interval_s = $_GET['sinceint'];
			}
			$id_test = $_GET['id'];
			$Id = $id_test;
			$rowCustomers = Db::getInstance()->ExecuteS('SELECT * FROM `'._DB_PREFIX_.'customer` WHERE deleted=0 AND id_customer ='.$id_test);
			$object_stored['customer'] = $rowCustomers;
			$requestGroups = Db::getInstance()->ExecuteS('SELECT * FROM `'._DB_PREFIX_.'customer_group` WHERE id_customer='.$id_test);
			$object_stored['groups'] = $requestGroups;
			$requestAddresses = Db::getInstance()->ExecuteS('SELECT * FROM `'._DB_PREFIX_.'address` WHERE deleted=0 AND id_customer='.$Id.' ORDER BY date_upd DESC');
			$object_stored['addresses'] = $requestAddresses;
			$rowConnection = Db::getInstance()->getRow('SELECT c.date_add, COUNT(cp.id_page) AS pages, TIMEDIFF(MAX(cp.time_end), c.date_add) as time, http_referer,INET_NTOA(ip_address) as ipaddress FROM `'._DB_PREFIX_.'guest` g LEFT JOIN `'._DB_PREFIX_.'connections` c ON c.id_guest = g.id_guest LEFT JOIN `'._DB_PREFIX_.'connections_page` cp ON c.id_connections = cp.id_connections WHERE g.id_customer = '.$Id.' GROUP BY c.id_connections ORDER BY c.date_add DESC');
			$object_stored['connection'] = $rowConnection;
			$requestOrders = Db::getInstance()->ExecuteS('SELECT total_paid,invoice_date,delivery_date FROM `'._DB_PREFIX_.'orders` WHERE valid=1 and id_customer='.$Id.' ORDER BY invoice_date DESC');
			$object_stored['orders'] = $requestOrders;
			$rowCancelledCart = Db::getInstance()->getRow('SELECT MAX(c.date_add) as date_add FROM '._DB_PREFIX_.'cart c LEFT JOIN '._DB_PREFIX_.'orders o ON (o.id_cart = c.id_cart) WHERE c.id_customer='.$Id.' AND DATE_SUB(NOW(),INTERVAL '.$interval_f.') <= c.date_add AND DATE_SUB(NOW(),INTERVAL '.$interval_s.') >= c.date_add AND o.id_order IS NULL');
			$object_stored['cart'] = $rowCancelledCart;
		} else {
			$object_stored['MB_APIKEY'] = '';
		}
		echo json_encode($object_stored);
	}
	elseif(($_GET['request'] == 'allgroupids') && ($accessKey == $_GET['accesskey']))
	{
		$request = Db::getInstance()->ExecuteS('SELECT id_group FROM `'._DB_PREFIX_.'group`');
		$i = 0;
        $idList = array(count($request));
		foreach ($request as $row)
		{
			$idList[$i++] = $row['id_group'];
		}
		Configuration::updateValue('MB_GROUP', join(',', $idList));
		echo json_encode($idList);
	}
	elseif(($_GET['request'] == 'recentcustomerids') && ($accessKey == $_GET['accesskey']))
	{
		$acceptInterfaceLevel = Configuration::get('MB_ACCEPTINTERFACELEVEL');
		$request = null;
		$date = pSQL($_GET['date']);
        
		if ($acceptInterfaceLevel == 'level1')
		{
			$sql = 'SELECT DISTINCT(id_customer) FROM `'._DB_PREFIX_.'customer` WHERE (date_add>\''.$date.'\') OR (date_upd>\''.$date.'\') OR (newsletter_date_add>\''.$date.'\') OR (id_customer IN (SELECT id_customer FROM `'._DB_PREFIX_.'address` WHERE date_add>\''.$date.'\' OR date_upd>\''.$date.'\')) OR (id_customer IN (SELECT id_customer FROM `'._DB_PREFIX_.'orders` WHERE date_add>\''.$date.'\' OR date_upd>\''.$date.'\')) OR (id_customer IN (SELECT id_customer FROM `'._DB_PREFIX_.'cart` WHERE date_add>DATE_SUB(CURDATE(),INTERVAL 7 DAY)))';
			$request = Db::getInstance()->ExecuteS($sql);

		}
		else
		{
			$sql = 'SELECT DISTINCT(id_customer) FROM `'._DB_PREFIX_.'customer` WHERE (date_add>\''.$date.'\') OR (date_upd>\''.$date.'\') OR (newsletter_date_add>\''.$date.'\') OR (id_customer IN (SELECT id_customer FROM `'._DB_PREFIX_.'address` WHERE date_add>\''.$date.'\' OR date_upd>\''.$date.'\'))';
			$request = Db::getInstance()->ExecuteS($sql);
		}

        $i = 0;
        $idList = array(count($request));
		foreach ($request as $row)
		{
            $idList[$i++] = $row['id_customer'];
		}
		echo json_encode($idList);//$xmlResult  . "\n";
	}
	elseif(($_GET['request']=='customerdata') && ($accessKey == $_GET['accesskey']) && isset($_POST['customersids']) && isset($_POST['moduleJob']) && ($_POST['moduleJob'] !== ''))
	{
        $return = array(
            'result' => 0,
            'message' => '',
            'idList' => array()
        );
        $idList = array();
        $ids = json_decode($_POST['customersids']);
        $moduleJob = json_decode($_POST['moduleJob']);
        $i = 0;
        $AttributeRelation = array();
        $ArrayContactKey = array();
        $ExistingValues = array();
		$interval_from = '2 DAY';
		$interval_since = '3 HOUR';
        foreach ($moduleJob->modFieldMb as $key => $value) {
            $AttributeRelation[$value->modFieldName] = $value->MbAttributeName;
			if ($value->jsonMapValues != null) {
				$value_exist = json_decode($value->jsonMapValues);
				$ExistingValues[$value->modFieldName] = array();
				foreach ($value_exist as $jindex_value => $jvalue_value) {
					//error_log($value->modFieldName . ' ' . $jindex_value . ' ' . $jvalue_value);
                    $ExistingValues[$value->modFieldName][$jindex_value] = $jvalue_value;
                }
			}
        }
		$mbGroup_string = ',';
		if (isset($AttributeRelation['id_group_customer'])) {
			$mbgroup = explode(",", Configuration::get('MB_GROUP'));
			if (isset($ExistingValues['id_group_customer'])) {
				foreach ($mbgroup as $mbIdx => $mbValue) {
					$mbGroup_string .= $ExistingValues['id_group_customer'][$mbValue].',';
				}
			}
		}
		
        $ContactList = array();
        $error = false;
        foreach ($ids as $id) {
            if (!is_numeric($id)) {
                $error = true;
            }
            $ArrayContactKey[$id] = $i++;
        }
        $return['result'] = $i;
		
        $contactsToSend = array();
        
		if (!$error && ($i > 0))
		{
            $CountryArray = array();
            $contactsApi = new Swagger\Client\Api\ContactsApi();
            initMessageBusinessApi($contactsApi->getApiClient()->getConfig(), Configuration::get('MB_ACCOUNTID'), Configuration::get('MB_APIKEY'));

            $rowCustomers = Db::getInstance()->ExecuteS('SELECT * FROM `'._DB_PREFIX_.'customer` WHERE deleted=0 AND id_customer IN ('.implode(', ', $ids).')');
			if ($rowCustomers)
			{
                foreach ($rowCustomers as $rowCustomer)
                {
                    $Id =  pSQL($rowCustomer['id_customer']);
                    $contact = new Swagger\Client\Model\ContactData;
                    $contactAttributes=[];
					if (isset($AttributeRelation['id_customer'])) {
						array_push($contactAttributes, getContactAttribute($AttributeRelation['id_customer'], $rowCustomer['id_customer']));
					}
                    if (isset($rowCustomer['id_shop']) && isset($AttributeRelation['id_shop'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['id_shop'], $rowCustomer['id_shop']));
                    }
                    if (isset($rowCustomer['id_shop_group']) && isset($AttributeRelation['id_shop_group'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['id_shop_group'], $rowCustomer['id_shop_group']));
                    }
                    $gender = '';
                    if ($rowCustomer['id_gender'] == 1) {
                        $gender = 'Monsieur';
                    } else if ($rowCustomer['id_gender'] == 2) {
                        $gender = 'Madame';
                    }
					if (isset($AttributeRelation['id_gender'])) {
						array_push($contactAttributes, getContactAttribute($AttributeRelation['id_gender'], $gender));
					}
					if (isset($AttributeRelation['firstname'])) {
						array_push($contactAttributes, getContactAttribute($AttributeRelation['firstname'], $rowCustomer['firstname']));
					}
					if (isset($AttributeRelation['lastname'])) {
						array_push($contactAttributes, getContactAttribute($AttributeRelation['lastname'], $rowCustomer['lastname']));
					}
					if (isset($AttributeRelation['email'])) {
						array_push($contactAttributes, getContactAttribute($AttributeRelation['email'], $rowCustomer['email']));
					}
                    if ($rowCustomer['birthday'] != 0 && isset($AttributeRelation['birthday'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['birthday'], date("Y-m-d", strtotime($rowCustomer['birthday']))));
                    }
					if (isset($AttributeRelation['optin'])) {
						$final_value = $rowCustomer['optin'];
						if (isset($ExistingValues['optin'])) {
							foreach ($ExistingValues['optin'] as $jidx => $jvalue) {
								if ($rowCustomer['optin'] == $jidx) {
									$final_value = $jvalue;
								}
							}
						}
						array_push($contactAttributes, getContactAttribute($AttributeRelation['optin'], $final_value));// check the id of the value with the mapping field
					}
					//TODO GROUP SHIT
					$mbgroup = Configuration::get('MB_GROUP');
					if (isset($AttributeRelation['id_group_customer'])) {
						$requestGroups = Db::getInstance()->ExecuteS('SELECT * FROM `'._DB_PREFIX_.'customer_group` WHERE id_customer='.$Id);
						$currentGroup = ',';
						foreach ($requestGroups as $rowGroup)
						{
							$groupCust = $rowGroup['id_group'] .'';
							if (isset($ExistingValues['id_group_customer'][$groupCust])) {
								$currentGroup .= $ExistingValues['id_group_customer'][$groupCust].',';
							}
						}
						//error_log($currentGroup.':'.$mbGroup_string);
						array_push($contactAttributes, getContactAttribute($AttributeRelation['id_group_customer'], $currentGroup.':'.$mbGroup_string));
					}
					if (isset($AttributeRelation['newsletter'])) {
						$final_value = $rowCustomer['newsletter'];
						if (isset($ExistingValues['newsletter'])) {
							foreach ($ExistingValues['newsletter'] as $jidx => $jvalue) {
								if ($rowCustomer['newsletter'] == $jidx) {//optin
									$final_value = $jvalue;
								}
							}
						}
						array_push($contactAttributes, getContactAttribute($AttributeRelation['newsletter'], $final_value));// check the id of the value with the mapping field
					}
                    if ($rowCustomer['newsletter_date_add'] != 0 && isset($AttributeRelation['newsletter_date_add'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['newsletter_date_add'], date("Y-m-d", strtotime($rowCustomer['newsletter_date_add']))));
                    }
                    if ($rowCustomer['date_add'] != 0 && isset($AttributeRelation['date_add'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['date_add'], date("Y-m-d", strtotime($rowCustomer['date_add']))));
                    }
					if (isset($AttributeRelation['id_customer'])) {
						array_push($contactAttributes, getContactAttribute($AttributeRelation['id_customer'], $rowCustomer['id_customer']));
                    }
                    
                    /**
                     * Add your custom field here
                     * array_push($contactAttributes, getContactAttribute('CUSTOM_FIELD_ID', 'VALUE_HERE'));
                     * e.g:
                     * array_push($contactAttributes, getContactAttribute('123', 'test'));
                     * More info about how to personalize this module : https://www.sendethic.com/campus/api-emailing-connecteurs/prestashop/prestashop-adaptez-le-module-message-business/
                    */

                    /*
                    * Query for the address, can be made once.
                    */
                    $requestAddresses = Db::getInstance()->ExecuteS('SELECT * FROM `'._DB_PREFIX_.'address` WHERE deleted=0 AND id_customer='.$Id.' ORDER BY date_upd DESC');
                    $score = array();
                    $address = array();
                    $i = 0;
                    foreach ($requestAddresses as $rowAddress)
                    {
                        if ($rowAddress['company'] != '') {
                            array_push($contactAttributes, getContactAttribute($AttributeRelation['company'], $rowAddress['company']));
                        }
                        $score[$i] = 0;
                        $address[$i] = array(
                            'address1' => $rowAddress['address1'],
                            'address2' => $rowAddress['address2'],
                            'postcode' => $rowAddress['postcode'],
                            'city' => $rowAddress['city'],
                            'phone_mobile' => $rowAddress['phone_mobile'],
                            'phone' => $rowAddress['phone'],
                        );
                        if ($rowAddress['address1'] != '') {
                            $score[$i] += 1;
                        }
                        if ($rowAddress['postcode'] != '') {
                            $score[$i] += 1;
                        }
                        if ($rowAddress['phone_mobile'] != '') {
                            $score[$i] += 7;
                        }
                        // Store this value so we don't call the database again
                        if (!isset($CountryArray[$rowAddress['id_country']])) {
                            if ($rowCountry = Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'country_lang` WHERE id_lang=1 AND id_country='.$rowAddress['id_country'].' '))
                            {
                                $CountryArray[$rowAddress['id_country']] = $rowCountry['name'];
                            }
                        }
                        if (isset($CountryArray[$rowAddress['id_country']])) {
                            $address[$i]['country'] = $CountryArray[$rowAddress['id_country']];
                            $score[$i] += 1;
                        }
                        $i++;
                    }
                    $cur = 0;
                    $cur_score = 0;
                    for ($x = 0; $x < $i; $x++) {
                        if ($cur_score < $score[$x]) {
                            $cur_score = $score[$x];
                            $cur = $x;
                        }
                    }
                    if (isset($address[$cur]['address1']) && isset($AttributeRelation['address1'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['address1'], $address[$cur]['address1']));
                    }
                    if (isset($address[$cur]['address2']) && isset($AttributeRelation['address2'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['address2'], $address[$cur]['address2']));
                    }
                    if (isset($address[$cur]['postcode']) && isset($AttributeRelation['postcode'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['postcode'], $address[$cur]['postcode']));
                    }
                    if (isset($address[$cur]['city']) && isset($AttributeRelation['city'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['city'], $address[$cur]['city']));
                    }
					if (isset($address[$cur]['country']) && isset($AttributeRelation['country'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['country'], $address[$cur]['country']));
                    }
                    if (isset($address[$cur]['phone_mobile']) && isset($AttributeRelation['phone_mobile'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['phone_mobile'], $address[$cur]['phone_mobile']));
                    }
                    if (isset($address[$cur]['phone']) && isset($AttributeRelation['phone'])) {
                        array_push($contactAttributes, getContactAttribute($AttributeRelation['phone'], $address[$cur]['phone']));
                    }
                    $acceptInterfaceLevel = Configuration::get('MB_ACCEPTINTERFACELEVEL');
                    if ($acceptInterfaceLevel == 'level1')
                    {
                        // Connection
                        if ($rowConnection = Db::getInstance()->getRow('SELECT c.date_add, COUNT(cp.id_page) AS pages, TIMEDIFF(MAX(cp.time_end), c.date_add) as time, http_referer,INET_NTOA(ip_address) as ipaddress FROM `'._DB_PREFIX_.'guest` g LEFT JOIN `'._DB_PREFIX_.'connections` c ON c.id_guest = g.id_guest LEFT JOIN `'._DB_PREFIX_.'connections_page` cp ON c.id_connections = cp.id_connections WHERE g.id_customer = '.$Id.' GROUP BY c.id_connections ORDER BY c.date_add DESC'))
                        {
                            if ($rowConnection['date_add'] != 0 && isset($AttributeRelation['last_connection'])) {
                                array_push($contactAttributes, getContactAttribute($AttributeRelation['last_connection'], date("Y-m-d", strtotime($rowConnection['date_add']))));
                            }
                        }
                        
                        // Orders
                        $requestOrders = Db::getInstance()->ExecuteS('SELECT total_paid,invoice_date,delivery_date FROM `'._DB_PREFIX_.'orders` WHERE valid=1 and id_customer='.$Id.' ORDER BY invoice_date ASC');
                        $invoice_date = strtotime( "0000-01-01");
                        $delivery_date = strtotime( "0000-01-01");
                        $orderArray = array();
                        $i = 0;
                        $totalAmount = 0;
                        foreach ($requestOrders as $rowOrder)
                        {
                            $orderArray[$i] = array(
                                'total_paid' => $rowOrder['total_paid'],
                                'invoice_date' => strtotime($rowOrder['invoice_date']),
                                'delivery_date' => strtotime($rowOrder['delivery_date'])
                            );
                            $totalAmount += $rowOrder['total_paid'];
                            $i++;
                        }
                        $count_orders = $i;
                        $lastOrderAmount = -1;
                        $lastOrderDate = '';
                        $lastDeliveryDate = '';
                        $firstOrderDate = '';
                        if ($count_orders > 0) {
                            $lastOrderAmount = $orderArray[$i-1]['total_paid'];
                            if ($orderArray[$i-1]['invoice_date'] != 0) {
                                $lastOrderDate = date("Y-m-d",$orderArray[$i-1]['invoice_date']);
                            }
                            if ($orderArray[$i-1]['delivery_date'] != 0) {
                                $lastDeliveryDate = date("Y-m-d",$orderArray[$i-1]['delivery_date']);
                            }
                            if ($orderArray[0]['invoice_date'] != 0) {
                                $firstOrderDate = date("Y-m-d",$orderArray[0]['invoice_date']);
                            }
                        }
                        if ($lastOrderDate !== '' && isset($AttributeRelation['lastorderdate'])) {
                            array_push($contactAttributes, getContactAttribute($AttributeRelation['lastorderdate'], $lastOrderDate));
                        }
                        if ($lastDeliveryDate !== '' && isset($AttributeRelation['lastdeliverydate'])) {
                            array_push($contactAttributes, getContactAttribute($AttributeRelation['lastdeliverydate'], $lastDeliveryDate));
                        }
						if (isset($AttributeRelation['lastordertotal'])) {
							if ($lastOrderAmount !== -1) {
								array_push($contactAttributes, getContactAttribute($AttributeRelation['lastordertotal'], $lastOrderAmount));
							} else {
								array_push($contactAttributes, getContactAttribute($AttributeRelation['lastordertotal'], ''));                    
							}
						}
                        if ($firstOrderDate !== '' && isset($AttributeRelation['firstorderdate'])) {
                            array_push($contactAttributes, getContactAttribute($AttributeRelation['firstorderdate'], $firstOrderDate));                    
                        }
                        $total_days = 0.0;
                        $count_orders_total = 0;
                        if ($count_orders > 1) {
                            for ($x = 0; $x < ($count_orders - 1); $x++) {
								if (isset($orderArray[$x+1]) && (isset($orderArray[$x])) && (is_numeric($orderArray[$x])) && (is_numeric($orderArray[$x]))) {
									$daysdiff = ($orderArray[$x+1] - $orderArray[$x]);
									$total_days += ($daysdiff/86400);//number of days
									$count_orders_total++;
								}
                            }
                            if ($count_orders_total > 0) {
                                $total_days = $total_days / $count_orders_total;
                            } else {
                                $total_days = 0;
                            }
							if (isset($AttributeRelation['ordersfrequency'])) {
								array_push($contactAttributes, getContactAttribute($AttributeRelation['ordersfrequency'], round($total_days))); 
							}
                        }
						if (isset($AttributeRelation['orderstotal'])) {
							array_push($contactAttributes, getContactAttribute($AttributeRelation['orderstotal'], $totalAmount));
						}
						if (isset($AttributeRelation['orderscount'])) {
							array_push($contactAttributes, getContactAttribute($AttributeRelation['orderscount'], $count_orders));
						}
                        // Last cancelled cart Date. SQL request coming from followup module
                        
                        //check the json map value
                        $interval_from = '2 DAY';
                        $interval_since = '3 HOUR';
                        if (isset($ExistingValues['lastcancelledcartdate'])) {
                            $interval_from = $ExistingValues['lastcancelledcartdate']['FROM'];
                            $interval_since = $ExistingValues['lastcancelledcartdate']['SINCE'];
                        }
						//error_log('SELECT MAX(c.date_add) as date_add FROM '._DB_PREFIX_.'cart c LEFT JOIN '._DB_PREFIX_.'orders o ON (o.id_cart = c.id_cart) WHERE c.id_customer='.$Id.' AND DATE_SUB(CURDATE(),INTERVAL '.$interval_from.') <= c.date_add AND DATE_SUB(CURDATE(),INTERVAL '.$interval_since.') >= c.date_add AND o.id_order IS NULL');
                        if ($rowCancelledCart = Db::getInstance()->getRow('SELECT MAX(c.date_add) as date_add FROM '._DB_PREFIX_.'cart c LEFT JOIN '._DB_PREFIX_.'orders o ON (o.id_cart = c.id_cart) WHERE c.id_customer='.$Id.' AND DATE_SUB(NOW(),INTERVAL '.$interval_from.') <= c.date_add AND DATE_SUB(NOW(),INTERVAL '.$interval_since.') >= c.date_add AND o.id_order IS NULL'))
                        {
                            if ($rowCancelledCart['date_add'] != 0 && isset($AttributeRelation['lastcancelledcartdate'])) {
								//error_log(date("Y-m-d H-i-s", strtotime($rowCancelledCart['date_add'])));
                                array_push($contactAttributes, getContactAttribute($AttributeRelation['lastcancelledcartdate'], date("Y-m-d H:i:s", strtotime($rowCancelledCart['date_add']))));
                            }
                        }
                    }
                    $contact->setContactKey($rowCustomer['email']);//CHECK WITH  $moduleJob->modUnicityField
                    $contact->setAttributes($contactAttributes);
                    array_push($contactsToSend, $contact);
                }
				
				try	{
					$return['message'] = str_replace('"', '', $contactsApi->contactsPostContactsAttributeKey($contactsToSend));
				} catch (Exception $error_send) {
					$return['message'] = str_replace('"', '',$error_send->getMessage()).str_replace('"', '*', json_encode($contactsToSend));
				}
				
				
                echo json_encode($return);
			}
			else
			{
				echo '{"result": 0, "message": "no customers pass"}';
			}
		}
		else
		{
			echo '{"result": 0, "message": "Empty id"}';
		}
	}
	else
	{
		echo '{"result": 0, "message": "Unknown or bad parameters"}';
	}
}
else
{
	echo '{"result": 0, "message": "Access denied for this IP"}';
}
?>