<?php
/*
	More info about how to personalize this module : https://www.sendethic.com/campus/api-emailing-connecteurs/prestashop/prestashop-adaptez-le-module-message-business/ 
*/
if (!defined('_PS_VERSION_'))
  exit;

require_once (dirname(__FILE__).'/autoload.php');
  
class sendethicv2 extends Module
{
    public function __construct()
    {
        $this->name = 'sendethicv2';
        $this->tab = 'administration';
        $this->version = '2.1';//version will be a float
        $this->author = 'Sendethic SAS';
        $this->need_instance = 0;
        $this->ps_versions_compliancy = array('min' => '1.4', 'max' => _PS_VERSION_); 
        $this->bootstrap = true;
//http://stackoverflow.com/questions/18614610/how-add-auto-update-functionality-to-prestashop-plugin
//http://doc.prestashop.com/display/PS15/Auto-updating+modules
        parent::__construct();

        $this->displayName = $this->l('Sendethic');
        $this->description = $this->l('This module allows you to extract customer data as well as newsletter subscribers of your PrestaShop site and import them into the database of contacts of a Sendethic account. With this module, you can also publish a form to allow newsletter subscribing on your site Prestashop.');

        $this->confirmUninstall = $this->l('Are you sure you want to delete the Sendethic Module ?');

        /*if (!Configuration::get('MYMODULE_NAME'))      
          $this->warning = $this->l('No name provided');*/
    }
	/*

if (parent::install() == false OR $this->registerHook('leftColumn') == false OR $this->registerHook('header') == false OR 
$this->registerHook('footer') == false)

*/
    public function install()
	{
	 	if (!parent::install() OR !$this->registerHook('rightColumn') OR !$this->registerHook('leftColumn') OR !$this->registerHook('footer')) return false;
		Configuration::updateValue('MB_ACCOUNTID', '');
		Configuration::updateValue('MB_APIKEY', '');
		Configuration::updateValue('MB_PSKEY', '');
		Configuration::updateValue('MB_ACCEPTINTERFACEOPTION', 'checked');
		Configuration::updateValue('MB_ACCEPTINTERFACELEVEL', 'level1');
		Configuration::updateValue('MB_ACCEPTBLOCK', '');
		Configuration::updateValue('MB_OPTINID', '');
		Configuration::updateValue('MB_OPTINIDYES', '');
		Configuration::updateValue('MB_OPTINIDNO', '');
		Configuration::updateValue('MB_DATEADD', '');
		Configuration::updateValue('MB_NEWSLETTER', '');
		Configuration::updateValue('MB_TEXTBOX', '');
		Configuration::updateValue('MB_IPS', '');
		Configuration::updateValue('MB_GROUP', '');
        Configuration::updateValue('MB_WEBURL', Tools::getShopDomain(true, false).__PS_BASE_URI__ . 'modules/sendethicv2');
	 	return true;
	}
	public function uninstall()
	{
	 	if (!parent::uninstall() OR !Configuration::deleteByName('MB_ACCOUNTID') OR !Configuration::deleteByName('MB_APIKEY') OR !Configuration::deleteByName('MB_ACCEPTINTERFACEOPTION') OR !Configuration::deleteByName('MB_ACCEPTINTERFACELEVEL') OR !Configuration::deleteByName('MB_ACCEPTBLOCK') OR !Configuration::deleteByName('MB_PSKEY') OR !Configuration::deleteByName('MB_OPTINID') OR !Configuration::deleteByName('MB_OPTINIDNO') OR !Configuration::deleteByName('MB_OPTINIDYES') OR !Configuration::deleteByName('MB_DATEADD') OR !Configuration::deleteByName('MB_WEBURL') OR !Configuration::deleteByName('MB_NEWSLETTER') OR !Configuration::deleteByName('MB_TEXTBOX') OR !Configuration::deleteByName('MB_IPS') OR !Configuration::deleteByName('MB_GROUP'))
	 		return false;
		else
			return true;
	}
    public function setContactAttribute($mb_key, $value) {
        $contactAttribute = new Swagger\Client\Model\ContactAttribute;
        $contactAttribute->setId($mb_key);
        $contactAttribute->setFieldValue($value);
        return ($contactAttribute);
    }
    private function _initMessageBusinessApi($config, $accountId, $apiKey) {
        $config->setUsername($accountId);
        $config->setPassword($apiKey);
        $config->setCurlTimeout(120);
        $config->setSSLVerification(false);
        return true;
    }
    /* Those hooks are use to set the newsletter panel in prestashop. You can find the html code in the hookme function, at the end... */
    public function hookLeftColumn($params)
	{
		$acceptBlock = Configuration::get('MB_ACCEPTBLOCK');
		if (!empty($acceptBlock) && ($acceptBlock == 'left'))
			return $this->hookMe($params);
		else
			return '';
	}
	public function hookRightColumn($params)
	{
		$acceptBlock = Configuration::get('MB_ACCEPTBLOCK');
		if (!empty($acceptBlock) && ($acceptBlock != 'left'))
			return $this->hookMe($params);
		else
			return '';
	}
	/*public function hookFooter($params)
	{
		$acceptBlock = Configuration::get('MB_ACCEPTBLOCK');
		//print_r("footer");
		if (!empty($acceptBlock)) {
			//print_r("footer");
			if ($acceptBlock == 'left') {
				return $this->hookLeftColumn($params);
			} else {
				return $this->hookRightColumn($params);
			}
		}
		return '';
	} */
    public function hookMe($params)
	{
		$error = false;
		$email = '';
		//$newsletterJson = '{ "operationId": 164, "isSuspended": false, "lastRunDate": "", "module_name": "", "type": "custom_export", "TableName": "", "operationType": "", "methodType": "", "modFieldMb": { "optin|105": { "modFieldLabel": "", "modFieldName": "optin", "modAttributeType": "", "MbAttributeName": "105", "MbUserDefined": true, "jsonMapValues": "" }, "newsletter|104": { "modFieldLabel": "", "modFieldName": "newsletter", "modAttributeType": "", "MbAttributeName": "104", "MbUserDefined": true, "jsonMapValues": "" }, "email|email": { "modFieldLabel": "", "modFieldName": "email", "modAttributeType": "", "MbAttributeName": "email", "MbUserDefined": false, "jsonMapValues": "" }, "id_customer|108": { "modFieldLabel": "", "modFieldName": "id_customer", "modAttributeType": "", "MbAttributeName": "108", "MbUserDefined": true, "jsonMapValues": "" }, "id_shop|109": { "modFieldLabel": "", "modFieldName": "id_shop", "modAttributeType": "", "MbAttributeName": "109", "MbUserDefined": true, "jsonMapValues": "" }, "id_shop_group|110": { "modFieldLabel": "", "modFieldName": "id_shop_group", "modAttributeType": "", "MbAttributeName": "110", "MbUserDefined": true, "jsonMapValues": "" } }, "modUnicityField": "", "mbUnicityField": "" }';
		$newsletterJson = Configuration::get('MB_NEWSLETTER');
		
		if (Tools::isSubmit('messagebusiness-newsletter-submit'))
		{
			$email = $_POST['messagebusiness_email'];
			$comment = '';
			if (!empty($email) && Validate::isEmail($email))
			{
				try
				{
					//$client = new SoapClient($this->_wsdl); 
					$accountId = Configuration::get('MB_ACCOUNTID');
					$apiKey = Configuration::get('MB_APIKEY');
                    
                    $contactApi = new Swagger\Client\Api\ContactApi();
                    $this->_initMessageBusinessApi($contactApi->getApiClient()->getConfig(), $accountId, $apiKey);
                    
                    $contact = new Swagger\Client\Model\ContactData;
                    $contactAttributes = array(
                        $this->setContactAttribute(Configuration::get('MB_DATEADD'), date("Y-m-d")),
                        $this->setContactAttribute('emailoptin', 'yes1'),
                        $this->setContactAttribute(Configuration::get('MB_OPTINID'), Configuration::get('MB_OPTINIDYES'))
                    );
                    $contact->setContactKey($email);
                    $contact->setAttributes($contactAttributes);
                    
                    $contactApi->contactPostContactAttributeKey($contact);
					$comment .= $this->l('Inscription confirmée');

					if (Module::isInstalled('blocknewsletter'))
					{
						// code from modules/blocknewsletter/blocknewsletter.php
						$registerStatus = $this->isNewsletterRegistered(pSQL($email));
						if ($registerStatus > 0)
						{
							// return $this->error = $this->l('E-mail address already registered');
						}
						/* If the user ins't a customer */
						elseif ($registerStatus == -1)
						{
							global $cookie;
							
							if (!Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'newsletter` (email, newsletter_date_add, ip_registration_newsletter, http_referer) VALUES (\''.pSQL($email).'\', NOW(), \''.pSQL(Tools::getRemoteAddr()).'\', (SELECT c.http_referer FROM `'._DB_PREFIX_.'connections` c WHERE c.id_guest = '.(int)($cookie->id_guest).' ORDER BY c.date_add DESC LIMIT 1))'))
							{
								$comment .= $this->l('An error has occurred during subscription.');
								$error = false;
							}
							try
							{
								// set active=1 for PS 1.5 
								Db::getInstance()->Execute('UPDATE `'._DB_PREFIX_.'newsletter` SET active=1 WHERE email=\''.pSQL($email).'\'');
							}
							catch(Exception $e1)
							{
							}
						}
						/* If the user is a customer */
						elseif ($registerStatus == 0)
						{
							if (!Db::getInstance()->Execute('UPDATE `'._DB_PREFIX_.'customer` SET newsletter = 1, newsletter_date_add = NOW(), ip_registration_newsletter = \''.pSQL(Tools::getRemoteAddr()).'\' WHERE email = \''.pSQL($email).'\''))
							{
								$comment .= $this->l('An error has occurred during subscription.');
								$error = false;
							}
						}
					}
				} 
				catch (Exception $e) 
				{ 
					$comment = $this->l('An error has occurred.') . '<br />' . $e->getMessage(); 
					$error = false;
				} 
			}
			else
			{
				$comment = $this->l('The email address you have typed is invalid.');
				$error = false;
			}
		}
		$newsletter_add_field = '';
		$AttributeRelation = array();
		if ($newsletterJson != '') 
		{
			$NewsLetterObj = json_decode(stripslashes($newsletterJson));
			if ($NewsLetterObj->modFieldMb) {
				foreach ($NewsLetterObj->modFieldMb as $key => $value) {
					$AttributeRelation[$value->modFieldName] = $value->MbAttributeName;
					$label_news = (($value->modFieldLabel) ? $value->modFieldLabel : $value->modFieldName);
					if (($value->modFieldName != 'email') && ($value->modFieldName != 'newsletter') && ($value->modFieldName != 'newsletter_date_add')) {
						if ($value->jsonMapValues != null) {
							$ExistingValues[$value->modFieldName] = json_decode($value->jsonMapValues);
							$newsletter_add_field .= '<tr><td>'.$this->l($label_news).'</td></tr><tr><td>
							<select id="mb_'.$value->MbAttributeName.'" type="text" name="mb_'.$value->MbAttributeName.'">';
							foreach ($ExistingValues[$value->modFieldName] as $key_json => $value_json) {
								$newsletter_add_field .= '<option value="'.$value_json.'">'.$key_json.'</option>';
							}
							$newsletter_add_field .= '</select></td></tr>';
						} else {
							$newsletter_add_field .= '<tr><td>'.$this->l($label_news).'</td></tr><tr><td>
							<input id="mb_'.$value->MbAttributeName.'" type="text" name="mb_'.$value->MbAttributeName.'" value="">
							</td></tr>';
						}
					}
				}
			}
			
		}
		
		// We don't use TPL files since they seem to be cached by default and upgrading or changing them in that scenario becomes complex to manage
		//<div class="block_content">
		if (version_compare(_PS_VERSION_, '1.6.0.0', '>'))
		{
			$mbform = '<!-- Block Sendethic module--><div id="newsletter_block_left" class="block"><h4>'.$this->l('Newsletter').
			'</h4><div class="block_content"><form method="POST"><table width="150"><tr><td>'.$this->l('E-mail :').'</td></tr><tr><td><input id="messagebusiness_email" type="text" name="messagebusiness_email" value="'.$email.'"></td></tr>';
			$mbform .= $newsletter_add_field;
			$mbform .= '<tr><td><input class="button" type="submit" name="messagebusiness-newsletter-submit"  value="'.$this->l('Subscribe').'"></td></tr></table><br />';
			if (!empty($comment))
			{
				if ($error)
					$mbform .= '<div id="messagebusiness_text" class="warning_inline">'.$comment.'</div><br />';
				else
					$mbform .= '<div id="messagebusiness_text" class="success_inline">'.$comment.'</div><br />';
			}
			$mbform .= '</form></div></div><!-- /Block Sendethic module-->';
		}
		else 
		{
			$mbform = '<!-- Block Sendethic module--><form method="POST"><div class="block"><h4>'.$this->l('Newsletter').'</h4><div class="block_content"><table width="150"><tr><td>'.$this->l('E-mail :').'</td></tr><tr><td><input id="messagebusiness_email" type="text" name="messagebusiness_email" value="'.$email.'"></td></tr>';
			$mbform .= $newsletter_add_field;
			$mbform .= '<tr><td><input class="button" type="submit" name="messagebusiness-newsletter-submit"  value="'.$this->l('Subscribe').'"></td></tr></table><br />';
			if (!empty($comment))
			{
				if ($error)
					$mbform .= '<div id="messagebusiness_text" class="warning_inline">'.$comment.'</div><br />';
				else
					$mbform .= '<div id="messagebusiness_text" class="success_inline">'.$comment.'</div><br />';
			}
			$mbform .= '</div></div></form><!-- /Block Sendethic module-->';			
		}
		return $mbform;
	}
    private function isNewsletterRegistered($customerEmail)
 	{
		// only if Module::isInstalled('blocknewsletter')
 	 	if (Db::getInstance()->getRow('SELECT email FROM `'._DB_PREFIX_.'newsletter` WHERE email = \''.pSQL($customerEmail).'\''))
 	 		return 1;
		if (!$registered = Db::getInstance()->getRow('SELECT newsletter FROM '._DB_PREFIX_.'customer WHERE email = \''.pSQL($customerEmail).'\''))
			return -1;
		if ($registered['newsletter'] == '1')
			return 2;
		return 0;
 	}
    function hookHeader($params)
	{
		error_log("test");
		if (version_compare(_PS_VERSION_,'1.5','<')) {
			Tools::addCSS(($this->_path).'blocknewsletter.css', 'all');
		} else {
			$this->context->controller->addCSS(_THEME_CSS_DIR_.’style.css’);
		}
	}
    /*if (!function_exists('curl_init'))
			$this->context->controller->informations[] = 'This module uses CURL, you should activate the PHP CURL extension on your server.';*/
    /*This part display the screen on the configuration of the module*/
    public function getContent()
	{
		$this->_html = '<h2>'.$this->displayName.'</h2>';
        if (!extension_loaded('curl')) $this->_html .= $this->displayError($this->l('Please install php extension <b>curl</b> before using this module.'));
		if (!extension_loaded('openssl')) $this->_html .= $this->displayError($this->l('Please install php extension <b>openssl</b> before using this module.'));
		$this->_displayForm();  
		return $this->_html;
	}
    
    private function _displayForm()
	{
        //Initialise MB values
        $accountId = Tools::getValue('MB_ACCOUNTID',Configuration::get('MB_ACCOUNTID'));
		$apiKey = Tools::getValue('MB_APIKEY',Configuration::get('MB_APIKEY'));
        $mb_url = Tools::getValue('MB_WEBURL',Configuration::get('MB_WEBURL'));
        $moduleApi = new Swagger\Client\Api\ModulesApi();
        $default_url = Tools::getShopDomain(true, false).__PS_BASE_URI__ . 'modules/sendethicv2';
        $this->_initMessageBusinessApi($moduleApi->getApiClient()->getConfig(), $accountId, $apiKey);
        
		$acceptInterfaceOption = Configuration::get('MB_ACCEPTINTERFACEOPTION');
		if (!empty($acceptInterfaceOption)) $acceptInterfaceOption = 'checked';
		$acceptInterfaceLevel0 = '';
		$acceptInterfaceLevel1 = '';
		$acceptInterfaceLevel = Configuration::get('MB_ACCEPTINTERFACELEVEL');
		if (!empty($acceptInterfaceLevel))
		{
			if ($acceptInterfaceLevel == 'level1')
				$acceptInterfaceLevel1 = 'checked="checked"';
			else
				$acceptInterfaceLevel0 = 'checked="checked"';
		}
		else
		{
			$acceptInterfaceLevel1 = 'checked="checked"';
		}
		$acceptBlock = Configuration::get('MB_ACCEPTBLOCK');
		$acceptBlockCheck = '';
		$acceptBlockLeft = '';
		$acceptBlockRight = '';
		if (!empty($acceptBlock))
		{
			$acceptBlockCheck = 'checked';
			if ($acceptBlock == 'right')
			{
				$acceptBlockLeft = '';
				$acceptBlockRight = 'selected';
			}
			else
			{
				$acceptBlockLeft = 'selected';
				$acceptBlockRight = '';
			}
		}
		$extractStatusLabel = '';
		$extractButtonLabel = '';
		$extractStatus = '';
        
        //Submit functions handling each button
        $submit_settings_operation = false;
        $mb_operationType = Tools::getValue('mb_typeOperation');
        if(Tools::isSubmit('messagebusiness-settings-submit'))
		{
			if (empty($accountId))
			{
				$this->_html .= $this->displayError($this->l('Please specify an account number.'));
			}
			else
			{
				Configuration::updateValue('MB_ACCOUNTID', pSQL($accountId));
                
				if (empty($apiKey))
					$this->_html .= $this->displayError($this->l('Please specify an API key.'));
				else
				{
					Configuration::updateValue('MB_APIKEY', pSQL($apiKey));
					try 
					{
                        $this->_initMessageBusinessApi($moduleApi->getApiClient()->getConfig(), $accountId, $apiKey);
                        
                        
                        $psKey = Configuration::get('MB_PSKEY');
                        if(empty($psKey))
                        {
                            Configuration::updateValue('MB_PSKEY', Tools::passwdGen(32));
                            $psKey = Configuration::get('MB_PSKEY');
                        }
						if (trim($mb_url) == '') {
							$mb_url = $default_url;
						}
                        Configuration::updateValue('MB_WEBURL', pSQL($mb_url));
                        $psSiteUrl = Tools::getShopDomain(true, false).__PS_BASE_URI__ ;
                        $moduleParameters = new Swagger\Client\Model\ModulesParameters;
                        $moduleParameters->setName('prestashop');
                        $moduleParameters->setVersion(_PS_VERSION_);
                        $moduleParameters->setModuleVersion($this->version);
                        $additional_params = array(
                            "accesskey" => $psKey,
                            "culture" => Configuration::get('PS_LOCALE_COUNTRY'),
                            "moduleUrl" => $mb_url
                        );
                        $moduleParameters->setParameters($additional_params);
                        $moduleApi->modulesPostModuleParams($moduleParameters);
                        
                        //$moduleTest = $moduleApi->modulesGetConnectionTest();
                        $this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('Settings saved').'" />'.$this->l('Your configuration settings have been saved.').'</div>';
					}
					catch (Exception $e)
					{
                        $this->_html .= $this->displayError($this->l('The Sendethic account number and / or the API key can not be validated. This may be a typing error while entering your account number or your API key. Create an account now ... It\'s free and without obligation ! If you already have an Sendethic account, please login, then go to the section "More > Your Settings > Language and Interface" and copy an already existing API key or generate a new one. Note: The new API key will be available one hour after its generation.'));
					} 
				}
			}
		}
        /*elseif(Tools::isSubmit('messagebusiness-block-submit'))
		{
			$acceptBlockCheck =  Tools::getValue('MB_ACCEPTBLOCK');
			if (!empty($acceptBlockCheck))
			{
				$acceptBlockCheck = 'checked';
				$acceptBlockCheckPosition =  Tools::getValue('MB_ACCEPTBLOCKPOSITION');
				if ($acceptBlockCheckPosition == 'right')
				{
					$acceptBlock = 'right';
					$acceptBlockLeft = '';
					$acceptBlockRight = 'selected';
				}
				else
				{
					$acceptBlock = 'left';
					$acceptBlockLeft = 'selected';
					$acceptBlockRight = '';
				}
				Configuration::updateValue('MB_ACCEPTBLOCKPOSITION',  pSQL($acceptBlockCheckPosition));
			}
			else
			{
				$acceptBlock = '';
				$acceptBlockLeft = '';
				$acceptBlockRight = 'selected';
			}
			Configuration::updateValue('MB_ACCEPTBLOCK', pSQL($acceptBlock));
			$this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('Settings saved').'" />'.$this->l('Your configuration settings have been saved.').'</div>';
		}*/
        elseif (Tools::isSubmit('messagebusiness-extract-submit'))
		{
            $submit_settings_operation = true;
			$acceptInterfaceOption =  Tools::getValue('MB_ACCEPTINTERFACEOPTION');
			if (!empty($acceptInterfaceOption)) $acceptInterfaceOption = 'checked';
			Configuration::updateValue('MB_ACCEPTINTERFACEOPTION', pSQL($acceptInterfaceOption));

			$acceptInterfaceLevel = Tools::getValue('MB_ACCEPTINTERFACELEVEL');
			if (empty($acceptInterfaceLevel)) $acceptInterfaceLevel = 'level0';
			if (!empty($acceptInterfaceLevel))
			{
				if ($acceptInterfaceLevel == 'level1')
					$acceptInterfaceLevel1 = 'checked="checked"';
				else
					$acceptInterfaceLevel0 = 'checked="checked"';
			}
			Configuration::updateValue('MB_ACCEPTINTERFACELEVEL', pSQL($acceptInterfaceLevel));
			try 
			{
				// send information to create the standard operation
				$standardOperation = new Swagger\Client\Model\StandardOperation;
				$standardOperation->setName("prestashop");
				if ($acceptInterfaceLevel === 'level1') {
					$standardOperation->setOptions(1);
				} else {
					$standardOperation->setOptions(0);
				}
				$newsOperation = new Swagger\Client\Model\StandardOperation;
				$newsOperation->setName('prestashop');
				$newsOperation->setOptions(1);
				$pres_answer = $moduleApi->modulesPostModuleStandardOp($standardOperation);
				/*$newsOpId = $moduleApi->modulesPostModuleNewsLetterOp($newsOperation);
				$newsletterNewOp = $moduleApi->modulesGetModuleOperation('prestashop', trim($newsOpId, '"'));
				Configuration::updateValue('MB_NEWSLETTER', pSQL($newsletterNewOp));*/
			}
			catch (Exception $e)
			{
				//$this->_html .= $this->displayError($this->l('An error has occured while sending values'));
				$this->_html .= $this->displayError($this->l('An error has occurred.') . '<br />' . $e->getMessage()); 
			}
		}
        elseif (!empty($mb_operationType) && (($mb_operationType == 1) || ($mb_operationType == 2))) // suspend / resume a job
        {
            try 
            {
                $ExistingOperationId =  Tools::getValue('mb_operationId');
                $operationIdtypeLabel = 'resumed.';
                if ($mb_operationType == 1) {//resumed
                    $moduleApi->modulesResumeModuleOperation($ExistingOperationId);
                } else if ($mb_operationType == 2) {//suspended
                    $operationIdtypeLabel = 'suspended.';
                    $moduleApi->modulesSuspendModuleOperation($ExistingOperationId);
                }
                $this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l($operationIdtypeLabel).'" />'.$this->l('The operation was '.$operationIdtypeLabel).'</div>';
            }
            catch (Exception $e)
            {
                $this->_html .= $this->displayError($this->l('An error has occurred.') . '<br />' . $e->getMessage()); 
            } 
        }
        elseif (!empty($mb_operationType) && $mb_operationType == 3) // delete a job
        {
            try 
            {
                $ExistingOperationId =  Tools::getValue('mb_operationId');
                $moduleApi->modulesDeleteSingleModuleOperation($ExistingOperationId);
                $this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('Deleted').'" />'.$this->l('The operation was deleted').'</div>';
            }
            catch (Exception $e)
            {
                $this->_html .= $this->displayError($this->l('An error has occurred.') . '<br />' . $e->getMessage()); 
            }
        }
        //Template part, version 1.4 
        $prestaOperations = null;
        if ((!empty($accountId)) && (!empty($apiKey))) {
			try
			{
				$prestaOperations = $moduleApi->modulesGetModuleOperations("prestashop");
			}
            catch (Exception $e)
            {
                $this->_html .= $this->displayError($this->l('An error has occurred.') . '<br />' . $e->getMessage()); 
            }
            //print_r($prestaOperations);
        }
        
        $extractButtonLabel = $this->l('Create import');
		$extractAdditionnalOption = '';
	 	$this->_html .= 
			'<fieldset style="background-color:#eeeeee;">
				<legend>'.$this->l('Credentials of your account on Sendethic').'</legend>
				<form id="messagebusiness-settings-form" action="" method="POST" style="float:left;" >
					<table>
						<tr>
							<td valign="top"><label style="text-align:right; white-space: nowrap;" >'.$this->l('Account number'). '</label></td>
							<td valign="top"><input style="width:250px;" type="text" name="MB_ACCOUNTID" value="'.htmlentities($accountId).'"></td>
						</tr>
						<tr>
							<td valign="top"><label style="text-align:right; white-space: nowrap;" >'.$this->l('Account API key').'</label></td>
							<td valign="top"><input style="width:250px;" type="text" name="MB_APIKEY" value="'.htmlentities($apiKey).'"></td>
						</tr>
                        <tr>
							<td valign="top"><label style="text-align:right; white-space: nowrap;" >'.$this->l('Public module URL').'</label></td>
							<td valign="top"><input style="width:250px;" type="text" name="MB_WEBURL" value="'.htmlentities($mb_url).'" /><span style="text-align:right; white-space: nowrap;">&nbsp;Ex: '.$default_url.'</span></td>
						</tr>
						<tr>
							<td valign="top">&nbsp;</td>
							<td valign="top"><input style="padding:5px; color:#fff; background-color:#0af; font-weight:bold; cursor:pointer;" type="submit" name="messagebusiness-settings-submit" value="'.$this->l('Save Settings').'">
							</td>
						</tr>
					</table>
				</form>
			</fieldset>';
			
            if (($prestaOperations !== null) && (count($prestaOperations) > 0)) {
				//$test = $this->l('custom_import').$this->l('custom_export').$this->l('custom_newsletter').$this->l('Suspend').$this->l('Resume');
                $this->_html .= '<br />
                <fieldset style="background-color:#eeeeee;">
                <legend>'.$this->l('Operations for prestashop').'</legend>
                <form id="messagebusiness-operation-form" name="messagebusiness-operation-form" action="" method="POST" style="float:left;" >
                    <table style="margin-left:129px;>
                        <tr style="border-bottom: 1px solid #ddd;">
                        <td style="padding: 15px; border-bottom: 1px solid #ddd; text-align: center;"><b>N°</b></td>
                        <td style="padding: 15px; border-bottom: 1px solid #ddd; text-align: center;"><b>'.$this->l('Name').'</b></td>
						<td style="padding: 15px; border-bottom: 1px solid #ddd; text-align: center;"><b>'.$this->l('Date').'</b></td>
                        <td style="padding: 15px; border-bottom: 1px solid #ddd; text-align: center;"><b></b></td></tr>';
                    foreach ($prestaOperations as $prestaOp) {
                        $operationIdtype = 2;
                        $operationIdtypeLabel = 'Suspend';
                        if ($prestaOp->getIsSuspended()) {
                            $operationIdtype = 1;
                            $operationIdtypeLabel = 'Resume';
                        }
						if ($prestaOp->getType() == 'custom_newsletter') {
							//$acceptBlock =  Configuration::get('MB_ACCEPTBLOCK');
							//$this->_html .= ((empty($acceptBlock)) ? $this->l('Suspendu') : $this->l('Active'));
							//$this->_html .= '<input style="padding:5px; color:#fff; background-color:#0af; font-weight:bold; cursor:pointer;" type="button" name="mb-operation-del'.$prestaOp->getOperationId().'" value="'.$this->l('Delete').'" onClick="setOperationId(\''.$prestaOp->getOperationId().'\', 3);">';
						} else {
                        $this->_html .= '<tr  style="border-bottom: 1px solid #ddd;">
                        <td style="padding: 15px; border-bottom: 1px solid #ddd;">'.$prestaOp->getOperationId().'</td>
                        <td style="padding: 15px; border-bottom: 1px solid #ddd;">'.$this->l($prestaOp->getType()).'</td>
						<td style="padding: 15px; border-bottom: 1px solid #ddd;">'.$prestaOp->getLastRunDate().'</td>
                        <td style="padding: 15px; border-bottom: 1px solid #ddd;"><input style="padding:5px; color:#fff; background-color:#0af; font-weight:bold; cursor:pointer;" type="button" name="mb-operation-type'.$prestaOp->getOperationId().'" value="'.$this->l($operationIdtypeLabel).'" onClick="setOperationId(\''.$prestaOp->getOperationId().'\', '.$operationIdtype.');"></td></tr>';
						//$this->_html .= '<input style="padding:5px; color:#fff; background-color:#0af; font-weight:bold; cursor:pointer;" type="button" name="mb-operation-del'.$prestaOp->getOperationId().'" value="'.$this->l('Delete').'" onClick="setOperationId(\''.$prestaOp->getOperationId().'\', 3);">';
						//$this->_html .= '</td></tr>';
                        }
                        
                    }
                    $this->_html .= '</table>
                        <input type="hidden" name="mb_operationId" id="mb_operationId" value="">
                        <input type="hidden" name="mb_typeOperation" id="mb_typeOperation" value="0">
                        <script language="javascript" type="text/javascript">
                        function setOperationId(id, type) {
                            document.getElementById("mb_operationId").value = id;
                            document.getElementById("mb_typeOperation").value = type;
                            document.getElementById("messagebusiness-operation-form").submit();
                        }
                        </script>
                        </form>
                    </fieldset>';/*'<br />
                <fieldset style="background-color:#eeeeee;">
                    <legend>'.$this->l('Newsletter Subscription Form').'</legend>
                    <form id="messagebusiness-block-form" action="" method="POST" style="float:left;" >
                        <table>
                            <tr>
                                <td valign="top"><label style="text-align:right;" ></label></td>
                                <td valign="top"><input name="MB_ACCEPTBLOCK" type="checkbox" '.$acceptBlockCheck.'>&nbsp;'.$this->l('Publish a newsletter subscription form and update the contact information on the PrestaShop website and the Sendethic account.').'<br /><br />'.$this->l('Position of the form on the home page of PrestaShop website').'&nbsp;:&nbsp;<select name="MB_ACCEPTBLOCKPOSITION"><option value="left" '.$acceptBlockLeft. '>'.$this->l('Left Column').'</option><option value="right" '.$acceptBlockRight. '>'.$this->l('Right Column').'</option></select></td>
                            </tr>
                            <tr>
                                <td valign="top">&nbsp;</td>
                                <td valign="top"><input style="padding:5px; color:#fff; background-color:#0af; font-weight:bold; cursor:pointer;" type="submit" name="messagebusiness-block-submit" value="'.$this->l('Save Settings').'">
                                </td>
                            </tr>
                        </table>
                    </form>
                </fieldset>';*/
            } else {
                $this->_html .= '<br />
                <fieldset style="background-color:#eeeeee;">
                    <legend>'.$this->l('Import contacts between databases').'</legend>
                    <form id="messagebusiness-extract-form" action="" method="POST" style="float:left;" >
                        <table>
                            <tr>
                                <td valign="top"><label style="text-align:right;" ></label></td>
                                <td valign="top">'.$this->l('Each day, the module imports the  data used to manage your marketing operations.').'</td>
                            </tr>
                            <tr>
                                <td valign="top"><label style="text-align:right;" ></label></td>
                                <td valign="top"><input type="radio" name="MB_ACCEPTINTERFACELEVEL" value="level1" '.$acceptInterfaceLevel1.' />&nbsp;'.$this->l('Import includes contact (email, name, ...), as well as customer data (Revenue, frequency).').'</td>
                            </tr>
                            <tr>
                                <td valign="top"><label style="text-align:right;" ></label></td>
                                <td valign="top"><input type="radio" name="MB_ACCEPTINTERFACELEVEL" value="level0" '.$acceptInterfaceLevel0.' />&nbsp;'.$this->l('Import only contact details (email, name, ...).').'</td>
                            </tr>
                            <tr>
                                <td valign="top"><label style="text-align:right;" ></label></td>
                                <td valign="top"><input style="padding:5px; color:#fff; background-color:#0af; font-weight:bold; cursor:pointer;" type="submit" name="messagebusiness-extract-submit" value="'.$extractButtonLabel.'">&nbsp;'.$extractStatusLabel.'</td>
                            </tr>
                            </table>
                    </form>
                </fieldset>';
            }
			$this->_html .= '<br />
			<fieldset style="background-color:#eeeeee;">
				<legend>'.$this->l('At your service').'</legend>
				<form id="messagebusiness-service-form" action="" method="POST" style="float:left;" >
					<table>
						<tr>
							<td valign="top"><label style="text-align:right;" ></label></td>
							<td valign="top">'.$this->l('Please contact us if you need additionnal information on this module. <br /><br />If you have not registered yet to Sendethic, create an account now ... It\'s free and without obligation !') .'</td>
						</tr>
					</table>
				</form>
			</fieldset>';
    }
}